"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Species(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_9 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.metadata.Species": opencb_1_3_0.Species,
        }

    __slots__ = [
        "id",
        "assembly",
        "scientificName",
        "strain",
        "taxonomyId",
    ]

    def __init__(
        self,
        id,
        assembly=None,
        scientificName=None,
        strain=None,
        taxonomyId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.Species model.

        :param id:
            Short species id. First letter from the first word + second word
            e.g. hsapiens for homo sapiens, mmusculus for mus
            musculus,...
        :type id: str
        :param assembly:
        :type assembly: None | str
        :param scientificName:
            Full scrientific name. e.g. homo sapiens, mus musculus,...
        :type scientificName: None | str
        :param strain:
        :type strain: None | str
        :param taxonomyId:
        :type taxonomyId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
